unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  TAGraph, TASeries, TATools, TASources, TAChartUtils;

type

  { TForm1 }

  TForm1 = class(TForm)
    Chart1: TChart;
    Chart1ConstantLine1: TConstantLine;
    Chart1LineSeries1: TLineSeries;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointDragTool1: TDataPointDragTool;
    PaintBox1: TPaintBox;
    RandomChartSource1: TRandomChartSource;
    procedure ChartToolset1DataPointDragTool1Drag(ASender: TDataPointDragTool;
      var AGraphPoint: TDoublePoint);
    procedure PaintBox1Paint(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.ChartToolset1DataPointDragTool1Drag(
  ASender: TDataPointDragTool; var AGraphPoint: TDoublePoint);
var
  P: TPoint;
  x: Integer;
  w: Integer;
begin
  P := Point(Chart1.XGraphToImage(AGraphPoint.X), 0);
  x := Chart1.ClientToParent(P).X - Paintbox1.Width div 2;
  if x < 0 then x := 0;
  if x + Paintbox1.Width > ClientWidth then x := ClientWidth - Paintbox1.Width;
  Paintbox1.Left := x;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var
  s: String;
begin
  with Paintbox1.Canvas do begin
    Brush.Color := clWhite;
    Pen.Color := clSilver;
    Rectangle(0, 0, Paintbox1.Width, Paintbox1.Height);
    s := FormatFloat('0.000', Chart1ConstantLine1.Position);
    TextOut((Paintbox1.Width - TextWidth(s)) div 2, (Paintbox1.Height - TextHeight(s)) div 2, s);
  end;
end;

end.

